// HWRECTView.h : interface of the CHWRECTView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_HWRECTVIEW_H__8B080E4F_DF7E_11D2_A2DF_00A0248D3AC7__INCLUDED_)
#define AFX_HWRECTVIEW_H__8B080E4F_DF7E_11D2_A2DF_00A0248D3AC7__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

// ɫͺɫ
#define WHITE RGB(255,255,255)
#define BLACK RGB(0,0,0)
#define BLUE RGB(0,0,255)

//½ƣƺ궨
#define LEFT 0
#define RIGHT 1
#define UP 2
#define DOWN 3


class CHWRECTView : public CView
{
protected: // create from serialization only
	CHWRECTView();
	DECLARE_DYNCREATE(CHWRECTView)

// Attributes
public:
	CHWRECTDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHWRECTView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CHWRECTView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	//е
	int m_iCol;
	int m_iRow;

	//СĴС,еĲͬͬΪ
	// 1210У30ص
	// 1815У20
	// 2420У15
	// 3025У12
	int m_iLarge;

	//ǰļ𣬻ٶȵ㷨Ϊ1500 - m_iLevel*200
	int m_iLevel;

	//ϷϽǵ
	int m_iStartX;
	int m_iStartY;

	void RectChange();
	BOOL RightIsLimit();
	BOOL LeftIsLimit();
	//ֲͬ״ĽӴ棬ӴָС飺ķʾ
	//˷ѵס
	//¼ЩӴڵǰ鶯̬λеԪغ
	int InterFace[74][4];
	
	//ǰķ״
	int m_currentRect;

	//жϵǰǷ񵽵
	void ActiveIsBottom();
	
	//ǰ½
	void RectDown();

	//ǰ٣UPƣLEFTƣRIGHT
	void RectArrow(int m_Type);
	
	//һʼʽݸǰ鶯̬λԼһνҪķλ
	void RectStatusToActiveStatus(int m_which);
	void RectStatusToNextStatus(int m_which);
	
	void ActiveStatusToGameStatus();
	int Random(int MaxNumber);
	//ʶѵ׵ıΪTRUE
	BOOL m_isBottom;

	//ڱ־״̬飬СɺݾΪ1ʾ÷ʾ߲ʾ
	//״ֻҪ޸ӦԪص״ֵ̬
	//ʱӿƣʱOnPaintи黭
	int GameStatus[100][100];

	//ڱ浱ǰĶ̬λã4Сֱڴеλ
	//λΪңÿһѭϺµԭ
	int ActiveStatus[4][2];

	//һҪķģ
	int NextStatus[4][2];

// Generated message map functions
protected:
	BOOL m_bGamePaush;
	void StopMid();
	void PlayMid();
	void CurrentAreaAndLevel();
	//ڼ¼ǰС뵱ǰַʾĻʾûǰ״̬
	CString m_strArea;
	CString m_strLevel;

	//ǰʽһֵʽ
	int m_icurrentStatus;
	int m_inextStatus;

	//OnDrawҪõ豸
	CPen *whitePen;
	CPen *blackPen;
	CBrush *blueBrush,*grayBrush,*blackBrush;

	//Ƿ
	BOOL m_bDrawGrid;

	//Ƿű
	BOOL m_bMusic;

	//Ϸܳɼ
	int m_iPerformance;

	//ϷǷѽΪFALSEʾʼΪ
	BOOL m_bGameEnd;
	
	//ˢָĴСΪĸСڵεĴС
	void InvalidateCurrent();
	//{{AFX_MSG(CHWRECTView)
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnGameStart();
	afx_msg void OnGameEnd();
	afx_msg void OnGameOption();
	afx_msg void OnUpdateGameStart(CCmdUI* pCmdUI);
	afx_msg void OnUpdateGameOption(CCmdUI* pCmdUI);
	afx_msg void OnUpdateGameEnd(CCmdUI* pCmdUI);
	afx_msg void OnUpdateGameExit(CCmdUI* pCmdUI);
	afx_msg void OnUpdateHelpAbout(CCmdUI* pCmdUI);
	afx_msg void OnUpdateHelpHelp(CCmdUI* pCmdUI);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnHelpHelp();
	afx_msg void OnUpdateOptionArea1(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionArea2(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionArea3(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionArea4(CCmdUI* pCmdUI);
	afx_msg void OnOptionArea1();
	afx_msg void OnOptionArea2();
	afx_msg void OnOptionArea3();
	afx_msg void OnOptionArea4();
	afx_msg void OnUpdateOptionLevel1(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionLevel2(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionLevel3(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionLevel4(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionLevel5(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionLevel6(CCmdUI* pCmdUI);
	afx_msg void OnOptionLevel1();
	afx_msg void OnOptionLevel2();
	afx_msg void OnOptionLevel3();
	afx_msg void OnOptionLevel4();
	afx_msg void OnOptionLevel5();
	afx_msg void OnOptionLevel6();
	afx_msg void OnUpdateOptionGrid(CCmdUI* pCmdUI);
	afx_msg void OnOptionGrid();
	afx_msg void OnUpdateOptionMusic(CCmdUI* pCmdUI);
	afx_msg void OnOptionMusic();
	afx_msg void OnUpdateGamePaush(CCmdUI* pCmdUI);
	afx_msg void OnGamePaush();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in HWRECTView.cpp
inline CHWRECTDoc* CHWRECTView::GetDocument()
   { return (CHWRECTDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HWRECTVIEW_H__8B080E4F_DF7E_11D2_A2DF_00A0248D3AC7__INCLUDED_)
